Subject: bug#11331: Emacs unnecessarily leaves behind stale auto-save files after crash recovery

From: Lars Ingebrigtsen <[email-masked]>
Date: Fri, 16 Jul 2021 13:29:57 +0200

Kelly Dean <[email-masked]> writes:

> Notice that the auto-save file remains, permanently, unless the buffer
> is later modified (which might not ever happen) and another auto-save
> operation overwrites the old auto-save file (which won't happen even
> if the buffer is modified, if the user saves the file before the
> auto-save timeout).

This is still the case in Emacs 28:

(defun basic-save-buffer (&optional called-interactively)
[...]
	(let ((recent-save (recent-auto-save-p))
[...]
            ;; If the auto-save file was recent before this command,
	    ;; delete it now.
	    (delete-auto-save-file-if-necessary recent-save))

`recent-auto-save-p' will return nil here, so FORCE to
`delete-auto-save-file-if-necessary' is nil.  If I'm reading the code
correctly, just passing in a t here would fix this issue.

(defun delete-auto-save-file-if-necessary (&optional force)
  "Delete auto-save file for current buffer if `delete-auto-save-files' is t.
Normally delete only if the file was written by this Emacs since
the last real save, but optional arg FORCE non-nil means delete anyway."

So this is on purpose (presumably to avoid deleting other instances'
auto-save files or something)...  but when we've just recovered from the
auto-save file, then it definitely should be deleted, I think.

I think...  fixing this would entail `recover-file' setting something.
Either a buffer-local variable, or setting auto_save_modified...  Hm!
`set-buffer-auto-saved'!

The following patch fixes the problem.

Does anybody have any comments to this approach?

diff --git a/lisp/files.el b/lisp/files.el
index ad02d373fd..be57763646 100644
--- a/lisp/files.el
+++ b/lisp/files.el
@@ -6508,7 +6508,8 @@ recover-file
 		 (coding-system-for-read 'auto-save-coding))
 	     (erase-buffer)
 	     (insert-file-contents file-name nil)
-	     (set-buffer-file-coding-system coding-system))
+	     (set-buffer-file-coding-system coding-system)
+             (set-buffer-auto-saved))
 	   (after-find-file nil nil t))
 	  (t (user-error "Recover-file canceled")))))

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no